#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	
	ofBackground(255, 100, 0);
	
	
	// listen on the given port
	cout << "listening for osc messages on port " << PORT << "\n";
	receiver.setup( PORT );
	
	current_msg_string = 0;
	mouseX = 0;
	mouseY = 0;
	mouseButtonState = "";
	
}

//--------------------------------------------------------------
void testApp::update(){
	
	
	
	
	//OSC STUFF START
	
	// hide old messages
	for ( int i=0; i<NUM_MSG_STRINGS; i++ )
	{
		if ( timers[i] < ofGetElapsedTimef() )
			msg_strings[i] = "";
	}
	
	// check for waiting messages
	while( receiver.hasWaitingMessages() )
	{
		// get the next message
		ofxOscMessage m;
		receiver.getNextMessage( &m );
		
		// check for mouse moved message
		if ( m.getAddress() == "/tuio/2Dcur" )
		{
			
			
			//// ZACH CODE
			
			if (m.getNumArgs() > 3){
			// both the arguments are int32's
			//int nothing = m.getArgAsInt32( 0 );
			int id  = m.getArgAsInt32( 1 );
			float x = m.getArgAsFloat( 2 );
			float y = m.getArgAsFloat( 3 );
			cout << id << " " << x << " " << y << endl;
				mouseDragged( x * ofGetWidth(), y * ofGetHeight(), 0);
			}
			
			
			
			
			////ZACH CODE
		}
		
		
		else if ( m.getAddress() == "/msaremote/accelerometer" )
		{
			
			
			//// ZACH CODE
			

				// both the arguments are int32's
				//int nothing = m.getArgAsInt32( 0 );
				q = m.getArgAsFloat( 0 );
				w = m.getArgAsFloat( 1 );
				e = m.getArgAsFloat( 2 );
				cout << q << " " << w << " " << e << endl;
				//mouseDragged( x * ofGetWidth(), y * ofGetHeight(), 0);
			
			
			
			
			////ZACH CODE
		}
		
		
		///old code 
		
		
//		 check for mouse button message
//		//else if ( m.getAddress() == "/mouse/button" )
//		{
//			// the single argument is a string
//			mouseButtonState = m.getArgAsString( 0 ) ;
//		}
//		else
//		{
//			// unrecognized message: display on the bottom of the screen
//			string msg_string;
//			msg_string = m.getAddress();
//			msg_string += ": ";
//			for ( int i=0; i<m.getNumArgs(); i++ )
//			{
//				// get the argument type
//				msg_string += m.getArgTypeName( i );
//				msg_string += ":";
//				// display the argument - make sure we get the right type
//				if( m.getArgType( i ) == OFXOSC_TYPE_INT32 )
//					msg_string += ofToString( m.getArgAsInt32( i ) );
//				else if( m.getArgType( i ) == OFXOSC_TYPE_FLOAT )
//					msg_string += ofToString( m.getArgAsFloat( i ) );
//				else if( m.getArgType( i ) == OFXOSC_TYPE_STRING )
//					msg_string += m.getArgAsString( i );
//				else
//					msg_string += "unknown";
//			}
//			// add to the list of strings to display
//			msg_strings[current_msg_string] = msg_string;
//			cout << msg_string<< endl;
//			timers[current_msg_string] = ofGetElapsedTimef() + 5.0f;
//			current_msg_string = ( current_msg_string + 1 ) % NUM_MSG_STRINGS;
//			// clear the next line
//			msg_strings[current_msg_string] = "";
//		}
		
		///old code
		
	}
	
	
	//OSC END
	

	
	
	
	
	
	
	

	for (int i = 0; i < pts.size(); i++){
		pts[i].x += ofRandom(-3, 3);
		pts[i].y += ofRandom(-3, 3);
//		
//		if (pts.size() > 300){
//			pts.erase(pts.begin());
//		}
		
//		pts[i].y += sin(ofGetElapsedTimef()) * 1.25;
//		
//		pts[i].x += cos(ofGetElapsedTimef()) * 1.25;
		
		pts[i].y += 20*q;
		
		pts[i].x += 20*w;
		
		
	

	}
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].update();
		
		
//		particles[i].pos.y += sin(ofGetElapsedTimef()) * 1.25;
//		
//		particles[i].pos.x += cos(ofGetElapsedTimef()) * 1.25;
		
		particles[i].pos.y += 20*q;
			
		particles[i].pos.x += 20*w;
		
		if (particles.size() > 600){
			particles.erase(particles.begin());
		}
		
		
	}
	
	//followPt.x = 0.96f * followPt.x + 0.04 * mouseX;
//	followPt.y = 0.96f * followPt.y + 0.04 * mouseY;
	
	

	
	
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
	


	ofNoFill();
	ofBeginShape();
	for (int i = 0; i < pts.size(); i++){
		ofCurveVertex(pts[i].x, pts[i].y);
		
			}
	
	ofEndShape();
	
	for (int i = 0; i < pts.size(); i++){
//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.2);
		ofCircle(pts[i].x, pts[i].y, q*200);
		ofSetColor(((pts[i].y)*1), ((pts[i].y)*0.25), 0);
		ofFill();
		
	}
	
//	for (int i = 0; i < pts.size(); i++){
//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.2);
//		ofSetColor(((pts[i].y)*1), ((pts[i].y)*0.25), 0);
//		ofFill();
//		
//	}
	
	
//	for (int i = 0; i < pts.size(); i++){
//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.2);
//		ofSetColor(((pts[i].y)*1), 0, 0);
//		ofNoFill();
//		ofEnableSmoothing();
//		
//	}
	
	// wireframe circles
	
//	for (int i = 0; i < pts.size(); i++){
//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.1);
//		ofSetColor(((pts[i].y)*1), 0, 0);
//		ofNoFill();
//		
//		ofEnableSmoothing();
//		
//	}
	
#pragma mark YOYO	
	
	/*
	 for (int i = 0; i < particles.size(); i++){
	 particles[i].draw();
	 }*/
	ofFill();
	//ofSetColor((ofRandom(0, 255)), (ofRandom(0, 255)), (ofRandom(0, 255)), 50);
	ofSetColor(255, 0, 0);

	ofBeginShape();
	for (int i = 0; i < particles
		 .size(); i++){
		ofCircle(particles[i].pos.x, particles[i].pos.y, 10);
		
	}
	
	
	
	ofEndShape();
	

	
//the interior shape
	
	// lines
	
	ofBeginShape();
	ofNoFill();
	ofSetColor(240, 0, 0);
	ofEnableSmoothing();
	
	for (int i = 0; i < particles.size(); i++){
		ofVertex(particles[i].pos.x, particles[i].pos.y);
	}
	
	ofEndShape();
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].pos.x += ofRandom(-2.25, 2.25);
		particles[i].pos.y += ofRandom(-2.25, 2.25);
		
//				pts[i].y += sin(ofGetElapsedTimef()) * 5;	
//				pts[i].x += cos(ofGetElapsedTimef()) * 5;
		
	}
	

	//small circle
	
//	ofNoFill();
//	for (int i = 0; i < particles.size(); i++){
//		//ofCircle(particles[i].pos.x, particles[i].pos.y, 3.5);
//		
//	}
	
	//ofRect(followPt.x, followPt.y, 4,4);
	
	
	
	
	///OSC START
	
	string buf;
	buf = "listening for osc messages on port" + ofToString( PORT );
	ofDrawBitmapString( buf, 10, 20 );
	
	// draw mouse state
	buf = "mouse: " + ofToString( mouseX, 4) +  " " + ofToString( mouseY, 4 );
	ofDrawBitmapString( buf, 430, 20 );
	ofDrawBitmapString( mouseButtonState, 580, 20 );
	
	for ( int i=0; i<NUM_MSG_STRINGS; i++ )
	{
		ofDrawBitmapString( msg_strings[i], 10, 40+15*i );
	}
	
	///OSC END
	

}

//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
	ofPoint myPt;
	myPt.x = x;
	myPt.y = y;
	pts.push_back(myPt);
	
	
	float dx = x - followPt.x;
	float dy = y - followPt.y;
	
	for (int i = 0; i < 5; i++){
	particle tempParticle;
	tempParticle.pos.set(x,y);
	tempParticle.vel.set( ofRandom(-1,1), ofRandom(-1,1));
//	tempParticle.vel.set( dx/80.0, dy/80.0);
	
	particles.push_back(tempParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

	pts.clear();
	particles.clear();
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

